//+------------------------------------------------------------------+
//|                                                       Signal.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  20013, Y"
#property link      "P8@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Magenta

extern int Risk     = 1;
extern int CandleTF = 240;
extern int BackBars = 300;
extern bool AlertOn = FALSE;
extern bool EmailOn = FALSE;
double g_ibuf_92[];
double g_ibuf_96[];
int gia_100[];
int gi_104 = 0;

int init() {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, g_ibuf_92);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, g_ibuf_96);
   SetIndexEmptyValue(1, 0.0);
   if (Period() > CandleTF) {
      Alert("DT-ZigZag: Please set to a higher TF ", CandleTF);
      return (0);
   }
   ArrayCopySeries(gia_100, 5, Symbol(), CandleTF);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int count_0;
   double icustom_4;
   int li_12 = IndicatorCounted();
   int li_16 = 300;
   if (li_12 < 0) return (-1);
   if (li_12 > 0) li_12--;
   li_16 = BackBars - li_12;
   for (int index_20 = 0; index_20 < li_16; index_20++) {
      if (Time[index_20] >= gia_100[0]) count_0 = 0;
      else {
         count_0 = ArrayBsearch(gia_100, Time[index_20 - 1], WHOLE_ARRAY, 0, MODE_DESCEND);
         if (Period() <= CandleTF) count_0++;
      }
      for (int li_24 = count_0; li_24 < count_0 + 100; li_24++) {
         icustom_4 = iCustom(NULL, CandleTF, "ZigZag", Risk, 5, 3, 0, li_24 + 1);
         if (icustom_4 != 0.0) break;
      }
      if (iClose(NULL, 0, index_20 + 1) <= icustom_4) g_ibuf_96[index_20] = icustom_4;
      else g_ibuf_96[index_20] = 0.0;
      if (iClose(NULL, 0, index_20 + 1) >= icustom_4) g_ibuf_92[index_20] = icustom_4;
      else g_ibuf_92[index_20] = 0.0;
      WindowRedraw();
   }
   if (g_ibuf_92[1] > 0.0 && gi_104 < 1) {
      if (AlertOn) Alert("Buy" + Symbol() + "[" + Period() + "m]");
      if (EmailOn) SendMail("Buy Alert!", "Buy" + Symbol() + "[" + Period() + "m]");
      gi_104 = 1;
   } else {
      if (g_ibuf_96[1] > 0.0 && gi_104 > -1) {
         if (AlertOn) Alert("Sell" + Symbol() + "[" + Period() + "m]");
         if (EmailOn) SendMail("Sell Alert!", "Sell" + Symbol() + "[" + Period() + "m]");
         gi_104 = -1;
      }
   }
   return (0);
}